/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         tellparse
#define yylex           telllex
#define yyerror         tellerror
#define yylval          telllval
#define yychar          tellchar
#define yydebug         telldebug
#define yynerrs         tellnerrs
#define yylloc          telllloc

/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 40 "tell_yacc.yy"

#include "tpdph.h"
#include <sstream>
#include "tellyzer.h"
#include "ted_prompt.h"
#include "outbox.h"
/* Switch on verbose error reporting messages*/
#define YYERROR_VERBOSE 1
/*Current command block - defined in tellyzer.cpp*/
extern parsercmd::cmdBLOCK*       CMDBlock;
namespace parsercmd
{
   extern int EOfile();
}

/*Current tell variable name*/
telldata::TellVar* tellvar = NULL;
std::stack<telldata::TellVar*> tellindxvar;
telldata::TellVar* tell_lvalue = NULL;
/*Current variable is a list. Legal values are:
  0 - not indexed
  1 - 1 index
  2 - 2 indexes*/
byte indexed  = 0;
byte lindexed = 0;
/*Current commands - parsed, but not yet in the command stack*/
std::stack<parsercmd::cmdFOREACH*> foreach_stack;
parsercmd::cmdLISTADD *listadd_command = NULL;
/*Current tell struct definition*/
telldata::TCompType *tellstruct = NULL;
/*Current tell callback definition*/
telldata::TCallBackType *tellcallback = NULL;
/* used for argument type checking during function call parse */
telldata::argumentQ   *argmap  = NULL;
/*taking care when a function is called from the argument list of another call*/
std::stack<telldata::argumentQ*>  argmapstack;

/* Current function declaration structure */
parsercmd::FuncDeclaration *cfd;
/*number of errors in a function defintion*/
int funcdeferrors = 0;

void tellerror(std::string s, TpdYYLtype loc);
void tellerror (std::string s);
void cleanonabort();



/* Line 268 of yacc.c  */
#line 128 "tell_yacc.cc"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 0,
     tknERROR = 258,
     tknIF = 259,
     tknELSE = 260,
     tknWHILE = 261,
     tknREPEAT = 262,
     tknUNTIL = 263,
     tknFOREACH = 264,
     tknSTRUCTdef = 265,
     tknVOIDdef = 266,
     tknREALdef = 267,
     tknBOOLdef = 268,
     tknINTdef = 269,
     tknSTRINGdef = 270,
     tknLAYOUTdef = 271,
     tknAUXDATAdef = 272,
     tknLISTdef = 273,
     tknCALLBACKdef = 274,
     tknRETURN = 275,
     tknTRUE = 276,
     tknFALSE = 277,
     tknLEQ = 278,
     tknGEQ = 279,
     tknEQ = 280,
     tknNEQ = 281,
     tknAND = 282,
     tknOR = 283,
     tknNOT = 284,
     tknBWAND = 285,
     tknBWOR = 286,
     tknBWNOT = 287,
     tknSW = 288,
     tknSE = 289,
     tknNE = 290,
     tknNW = 291,
     tknPREADD = 292,
     tknPRESUB = 293,
     tknPOSTADD = 294,
     tknPOSTSUB = 295,
     tknCONST = 296,
     tknIDENTIFIER = 297,
     tknTYPEdef = 298,
     tknFIELD = 299,
     tknSTRING = 300,
     tknREAL = 301,
     tknINT = 302
   };
#endif
/* Tokens.  */
#define END 0
#define tknERROR 258
#define tknIF 259
#define tknELSE 260
#define tknWHILE 261
#define tknREPEAT 262
#define tknUNTIL 263
#define tknFOREACH 264
#define tknSTRUCTdef 265
#define tknVOIDdef 266
#define tknREALdef 267
#define tknBOOLdef 268
#define tknINTdef 269
#define tknSTRINGdef 270
#define tknLAYOUTdef 271
#define tknAUXDATAdef 272
#define tknLISTdef 273
#define tknCALLBACKdef 274
#define tknRETURN 275
#define tknTRUE 276
#define tknFALSE 277
#define tknLEQ 278
#define tknGEQ 279
#define tknEQ 280
#define tknNEQ 281
#define tknAND 282
#define tknOR 283
#define tknNOT 284
#define tknBWAND 285
#define tknBWOR 286
#define tknBWNOT 287
#define tknSW 288
#define tknSE 289
#define tknNE 290
#define tknNW 291
#define tknPREADD 292
#define tknPRESUB 293
#define tknPOSTADD 294
#define tknPOSTSUB 295
#define tknCONST 296
#define tknIDENTIFIER 297
#define tknTYPEdef 298
#define tknFIELD 299
#define tknSTRING 300
#define tknREAL 301
#define tknINT 302




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 237 "tell_yacc.yy"

   float                       real;
   bool                        ptypedef;
   int                         integer;
   char*                       parsestr;
    telldata::typeID           pttname;
   parsercmd::ArgumentLIST*    pfarguments;
    telldata::argumentQ*       plarguments;
    telldata::ArgumentID*      parguments;
   parsercmd::cmdBLOCK*        pblock;
   parsercmd::cmdFUNC*         pfblock;
   parsercmd::FuncDeclaration* pfdeclaration;
/*    telldata::TCallBackType*   pfcallbackdef;*/



/* Line 293 of yacc.c  */
#line 277 "tell_yacc.cc"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 302 "tell_yacc.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  89
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   735

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  64
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  73
/* YYNRULES -- Number of rules.  */
#define YYNRULES  165
/* YYNRULES -- Number of states.  */
#define YYNSTATES  283

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   302

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      49,    50,    62,    60,    54,    61,     2,    63,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    57,    48,
      58,    53,    59,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    55,     2,    56,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    51,     2,    52,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    15,    17,    19,
      21,    22,    29,    32,    34,    36,    37,    42,    45,    47,
      50,    51,    58,    60,    61,    66,    67,    68,    76,    78,
      79,    80,    90,    91,    92,   101,   103,   106,   110,   112,
     115,   117,   120,   123,   125,   127,   129,   131,   134,   137,
     140,   143,   146,   149,   150,   156,   160,   164,   165,   167,
     169,   171,   173,   175,   177,   181,   182,   184,   186,   190,
     193,   195,   197,   199,   201,   203,   205,   208,   214,   218,
     222,   225,   227,   230,   232,   234,   236,   238,   240,   242,
     244,   246,   248,   249,   257,   258,   265,   266,   268,   270,
     274,   276,   277,   284,   286,   290,   293,   295,   297,   302,
     309,   315,   320,   326,   331,   337,   342,   348,   353,   360,
     366,   373,   379,   380,   385,   388,   393,   395,   399,   403,
     405,   409,   413,   415,   419,   423,   425,   429,   433,   437,
     441,   443,   447,   451,   455,   459,   463,   467,   469,   473,
     477,   479,   482,   485,   488,   490,   492,   494,   496,   498,
     500,   502,   504,   506,   510,   512
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      65,     0,    -1,    66,    -1,    65,    66,    -1,    91,    -1,
      69,    -1,    67,    48,    -1,     3,    -1,     0,    -1,     1,
      -1,    -1,   105,    42,    49,    68,    98,    50,    -1,    67,
      70,    -1,    73,    -1,    71,    -1,    -1,    51,    72,    90,
      52,    -1,    51,    52,    -1,    20,    -1,    20,    96,    -1,
      -1,     4,    49,   129,    50,    76,    89,    -1,    75,    -1,
      -1,    75,     5,    78,    89,    -1,    -1,    -1,     6,    49,
      80,   129,    50,    81,    89,    -1,   129,    -1,    -1,    -1,
       9,    49,    84,   101,    48,    82,    50,    85,    89,    -1,
      -1,    -1,     7,    87,    89,     8,    49,    88,   129,    50,
      -1,    91,    -1,    51,    52,    -1,    51,    90,    52,    -1,
      91,    -1,    90,    91,    -1,    48,    -1,   103,    48,    -1,
      94,    48,    -1,    77,    -1,    79,    -1,    83,    -1,    86,
      -1,    74,    48,    -1,    92,    48,    -1,   123,    48,    -1,
     124,    48,    -1,   114,    48,    -1,   107,    48,    -1,    -1,
      42,    49,    93,    95,    50,    -1,   101,    53,    96,    -1,
     122,    53,    96,    -1,    -1,    97,    -1,   129,    -1,    94,
      -1,   125,    -1,   127,    -1,    96,    -1,    97,    54,    96,
      -1,    -1,    99,    -1,   100,    -1,    99,    54,   100,    -1,
     105,    42,    -1,   102,    -1,   103,    -1,    42,    -1,   117,
      -1,   120,    -1,   121,    -1,   105,    42,    -1,   105,    42,
     118,   129,   119,    -1,    41,   105,    42,    -1,   103,    54,
      42,    -1,   105,    42,    -1,   106,    -1,   106,    18,    -1,
     109,    -1,    11,    -1,    12,    -1,    14,    -1,    13,    -1,
      15,    -1,    16,    -1,    17,    -1,    43,    -1,    -1,    19,
     105,    42,    49,   108,   111,    50,    -1,    -1,    19,   105,
      49,   110,   111,    50,    -1,    -1,   112,    -1,   113,    -1,
     112,    54,   113,    -1,   105,    -1,    -1,    10,    42,   115,
      51,   116,    52,    -1,   104,    -1,   116,    48,   104,    -1,
     102,    44,    -1,    55,    -1,    56,    -1,   102,   118,   129,
     119,    -1,   102,   118,   129,    57,   129,   119,    -1,   102,
     118,    37,   129,   119,    -1,   102,   118,    37,   119,    -1,
     102,   118,   129,    39,   119,    -1,   102,   118,    39,   119,
      -1,   102,   118,    38,   129,   119,    -1,   102,   118,    38,
     119,    -1,   102,   118,   129,    40,   119,    -1,   102,   118,
      40,   119,    -1,   102,   118,   129,    38,   129,   119,    -1,
     102,   118,   129,    38,   119,    -1,   102,   118,   129,    40,
     129,   119,    -1,   102,   118,    40,   129,   119,    -1,    -1,
      51,   126,    95,    52,    -1,    30,    42,    -1,    49,   105,
      50,   125,    -1,   130,    -1,   129,    28,   130,    -1,   129,
      31,   130,    -1,   131,    -1,   130,    27,   131,    -1,   130,
      30,   131,    -1,   132,    -1,   131,    25,   132,    -1,   131,
      26,   132,    -1,   133,    -1,   132,    58,   133,    -1,   132,
      59,   133,    -1,   132,    23,   133,    -1,   132,    24,   133,
      -1,   134,    -1,   133,    60,   134,    -1,   133,    61,   134,
      -1,   133,    35,   134,    -1,   133,    36,   134,    -1,   133,
      34,   134,    -1,   133,    33,   134,    -1,   135,    -1,   134,
      62,   135,    -1,   134,    63,   135,    -1,   136,    -1,    61,
     136,    -1,    29,   136,    -1,    32,   136,    -1,    46,    -1,
      47,    -1,    21,    -1,    22,    -1,    45,    -1,   102,    -1,
     128,    -1,   123,    -1,   124,    -1,    49,   129,    50,    -1,
      92,    -1,     3,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   286,   286,   287,   291,   303,   304,   307,   311,   314,
     323,   323,   334,   343,   344,   348,   348,   359,   365,   377,
     393,   393,   412,   416,   416,   429,   433,   429,   448,   459,
     463,   459,   482,   486,   482,   504,   505,   506,   510,   511,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   531,   531,   559,   565,   573,   574,   578,
     579,   580,   581,   585,   586,   590,   591,   595,   596,   600,
     609,   610,   614,   625,   626,   627,   633,   644,   659,   670,
     683,   696,   697,   698,   702,   703,   704,   705,   706,   707,
     708,   709,   720,   720,   738,   738,   751,   752,   756,   757,
     761,   767,   767,   785,   786,   790,   817,   823,   831,   843,
     856,   866,   876,   886,   899,   904,   911,   916,   926,   935,
     944,   953,   965,   965,   989,   997,  1019,  1020,  1021,  1025,
    1026,  1027,  1031,  1032,  1033,  1037,  1038,  1039,  1040,  1041,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1055,  1056,  1057,
    1061,  1062,  1063,  1064,  1068,  1070,  1072,  1074,  1076,  1079,
    1081,  1083,  1084,  1085,  1086,  1087
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of command/file\"", "error", "$undefined", "tknERROR", "tknIF",
  "tknELSE", "tknWHILE", "tknREPEAT", "tknUNTIL", "tknFOREACH",
  "tknSTRUCTdef", "tknVOIDdef", "tknREALdef", "tknBOOLdef", "tknINTdef",
  "tknSTRINGdef", "tknLAYOUTdef", "tknAUXDATAdef", "tknLISTdef",
  "tknCALLBACKdef", "tknRETURN", "tknTRUE", "tknFALSE", "tknLEQ", "tknGEQ",
  "tknEQ", "tknNEQ", "tknAND", "tknOR", "tknNOT", "tknBWAND", "tknBWOR",
  "tknBWNOT", "tknSW", "tknSE", "tknNE", "tknNW", "tknPREADD", "tknPRESUB",
  "tknPOSTADD", "tknPOSTSUB", "tknCONST", "tknIDENTIFIER", "tknTYPEdef",
  "tknFIELD", "tknSTRING", "tknREAL", "tknINT", "';'", "'('", "')'", "'{'",
  "'}'", "'='", "','", "'['", "']'", "':'", "'<'", "'>'", "'+'", "'-'",
  "'*'", "'/'", "$accept", "input", "entrance", "funcdeclaration", "$@1",
  "funcdefinition", "funcblock", "fblock", "$@2", "emptyfblock",
  "returnstatement", "ifcommon", "$@3", "ifstatement", "$@4",
  "whilestatement", "$@5", "$@6", "telllist", "foreachstatement", "$@7",
  "$@8", "repeatstatement", "$@9", "$@10", "blockstatement", "statements",
  "statement", "funccall", "$@11", "assignment", "arguments", "argument",
  "nearguments", "funcarguments", "funcneargument", "funcargument",
  "lvalue", "variable", "variabledeclaration", "fielddeclaration",
  "telltypeID", "telltype", "callbacktypedef", "$@12",
  "callbackanotypedef", "$@13", "anoarguments", "anoneargument",
  "anoargument", "recorddefinition", "$@14", "typedefstruct", "fieldname",
  "indxb", "indxe", "listindex", "listrange", "listinsert", "listremove",
  "listslice", "structure", "$@15", "funcreference", "anonymousvar",
  "expression", "andexpression", "eqexpression", "relexpression",
  "addexpression", "multiexpression", "unaryexpression",
  "primaryexpression", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    59,    40,
      41,   123,   125,    61,    44,    91,    93,    58,    60,    62,
      43,    45,    42,    47
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    64,    65,    65,    66,    66,    66,    66,    66,    66,
      68,    67,    69,    70,    70,    72,    71,    73,    74,    74,
      76,    75,    77,    78,    77,    80,    81,    79,    82,    84,
      85,    83,    87,    88,    86,    89,    89,    89,    90,    90,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    93,    92,    94,    94,    95,    95,    96,
      96,    96,    96,    97,    97,    98,    98,    99,    99,   100,
     101,   101,   102,   102,   102,   102,   103,   103,   103,   103,
     104,   105,   105,   105,   106,   106,   106,   106,   106,   106,
     106,   106,   108,   107,   110,   109,   111,   111,   112,   112,
     113,   115,   114,   116,   116,   117,   118,   119,   120,   121,
     122,   122,   122,   122,   123,   123,   123,   123,   124,   124,
     124,   124,   126,   125,   127,   128,   129,   129,   129,   130,
     130,   130,   131,   131,   131,   132,   132,   132,   132,   132,
     133,   133,   133,   133,   133,   133,   133,   134,   134,   134,
     135,   135,   135,   135,   136,   136,   136,   136,   136,   136,
     136,   136,   136,   136,   136,   136
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     2,     1,     1,     1,
       0,     6,     2,     1,     1,     0,     4,     2,     1,     2,
       0,     6,     1,     0,     4,     0,     0,     7,     1,     0,
       0,     9,     0,     0,     8,     1,     2,     3,     1,     2,
       1,     2,     2,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     2,     0,     5,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     3,     0,     1,     1,     3,     2,
       1,     1,     1,     1,     1,     1,     2,     5,     3,     3,
       2,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     7,     0,     6,     0,     1,     1,     3,
       1,     0,     6,     1,     3,     2,     1,     1,     4,     6,
       5,     4,     5,     4,     5,     4,     5,     4,     6,     5,
       6,     5,     0,     4,     2,     4,     1,     3,     3,     1,
       3,     3,     1,     3,     3,     1,     3,     3,     3,     3,
       1,     3,     3,     3,     3,     3,     3,     1,     3,     3,
       1,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     8,     9,     7,     0,     0,    32,     0,     0,    84,
      85,    87,    86,    88,    89,    90,     0,    18,     0,    72,
      91,    40,     0,     2,     0,     5,     0,    22,    43,    44,
      45,    46,     4,     0,     0,     0,    70,    71,     0,    81,
       0,    83,     0,    73,    74,    75,     0,     0,     0,     0,
      25,     0,    29,   101,     0,     0,   165,   156,   157,     0,
       0,     0,   158,   154,   155,     0,   122,     0,   164,    60,
      19,   159,    71,     0,   161,   162,    61,    62,   160,    59,
     126,   129,   132,   135,   140,   147,   150,     0,    53,     8,
       3,     6,    15,    12,    14,    13,    47,    23,    48,    42,
       0,   105,   106,     0,    41,     0,    76,    82,    52,    51,
       0,    49,    50,   159,     0,     0,     0,     0,    35,     0,
       0,     0,     0,    94,   152,   124,   153,     0,     0,    57,
     151,    76,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      78,    57,    17,     0,     0,    55,     0,     0,     0,     0,
       0,    79,    10,     0,    56,     0,    20,     0,    36,     0,
      38,     0,    72,     0,    70,     0,    92,    96,     0,   163,
       0,    63,    58,   127,   128,   130,   131,   133,   134,   138,
     139,   136,   137,   146,   145,   143,   144,   141,   142,   148,
     149,     0,     0,    24,   107,   111,     0,   115,     0,   113,
     117,     0,     0,     0,     0,     0,   108,    65,     0,     0,
       0,    26,    37,    39,    33,     0,     0,   103,     0,     0,
      96,   100,     0,    97,    98,   125,   123,     0,    54,    16,
     110,   114,   121,   119,     0,   112,   116,     0,     0,     0,
      66,    67,     0,    77,    21,     0,     0,     0,    28,     0,
      80,     0,   102,     0,    95,     0,    64,   118,   120,   109,
      11,     0,    69,    27,     0,    30,   104,    93,    99,    68,
      34,     0,    31
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    22,    23,    24,   217,    25,    93,    94,   153,    95,
      26,    27,   220,    28,   154,    29,   115,   255,   257,    30,
     119,   281,    31,    51,   256,   117,   169,   118,    68,   151,
      34,   180,   181,   182,   249,   250,   251,    35,   113,    37,
     227,    73,    39,    40,   230,    41,   177,   232,   233,   234,
      42,   120,   229,    43,   103,   216,    44,    45,    46,    74,
      75,    76,   129,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -142
static const yytype_int16 yypact[] =
{
     463,  -142,  -142,  -142,   -33,    -9,  -142,     7,    25,  -142,
    -142,  -142,  -142,  -142,  -142,  -142,   151,   281,   151,    33,
    -142,  -142,   509,  -142,    -6,  -142,    37,    88,  -142,  -142,
    -142,  -142,  -142,    51,    73,    42,   -21,   -23,    55,    99,
      86,  -142,    90,  -142,  -142,  -142,    83,    98,   124,    17,
    -142,   637,  -142,  -142,   151,    -1,  -142,  -142,  -142,   224,
     108,   224,  -142,  -142,  -142,   322,  -142,   224,  -142,  -142,
    -142,   -34,   120,   134,  -142,  -142,  -142,  -142,  -142,    30,
      47,    76,    12,    71,    49,  -142,  -142,   140,  -142,  -142,
    -142,  -142,   138,  -142,  -142,  -142,  -142,  -142,  -142,  -142,
     281,  -142,  -142,   352,  -142,   150,    32,  -142,  -142,  -142,
     281,  -142,  -142,   -21,    19,    17,   526,   187,  -142,   692,
     149,   152,   156,  -142,  -142,  -142,  -142,   157,    95,   281,
    -142,   154,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
    -142,   281,  -142,   654,   637,  -142,   404,   404,   161,   404,
      52,  -142,  -142,    17,  -142,   374,  -142,    97,  -142,   573,
    -142,   181,  -142,   183,   -21,   151,  -142,   151,   184,  -142,
     182,  -142,   186,    47,    47,    76,    76,    12,    12,    71,
      71,    71,    71,    49,    49,    49,    49,    49,    49,  -142,
    -142,   192,   590,  -142,  -142,  -142,   -19,  -142,   -19,  -142,
    -142,   -19,   404,   161,   404,    17,  -142,   151,   -19,   319,
     637,  -142,  -142,  -142,  -142,    17,    17,  -142,   201,    20,
     151,  -142,   194,   193,  -142,  -142,  -142,   281,  -142,  -142,
    -142,  -142,  -142,  -142,   -19,  -142,  -142,   -19,   -19,   198,
     202,  -142,   216,  -142,  -142,   637,    17,   210,    30,   -13,
    -142,   151,  -142,   212,  -142,   151,  -142,  -142,  -142,  -142,
    -142,   151,  -142,  -142,   102,  -142,  -142,  -142,  -142,  -142,
    -142,   637,  -142
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -142,  -142,   241,  -142,  -142,  -142,  -142,  -142,  -142,  -142,
    -142,  -142,  -142,  -142,  -142,  -142,  -142,  -142,  -142,  -142,
    -142,  -142,  -142,  -142,  -142,  -141,   111,     8,     2,  -142,
     -14,   114,   -12,  -142,  -142,  -142,    -4,   155,     0,   -16,
      14,    11,  -142,  -142,  -142,  -142,  -142,    38,  -142,    13,
    -142,  -142,  -142,  -142,   -99,   -15,  -142,  -142,  -142,     4,
       6,   101,  -142,  -142,  -142,    24,    16,    44,    48,   113,
      69,    70,    -7
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -71
static const yytype_int16 yytable[] =
{
      36,    72,    33,    69,    47,    70,    48,   163,    32,   132,
     101,    38,   133,   203,   165,   132,    49,    71,   133,   -70,
      56,   102,    36,   101,    33,   104,    47,    55,    48,    87,
      32,   105,   163,    38,   102,   138,   139,   204,    57,    58,
      50,   122,    91,   204,   215,    92,    59,   132,   123,    61,
     133,    36,   124,    33,   126,    47,    52,    48,   132,    19,
     130,   133,    62,    63,    64,   121,    65,    53,   261,   166,
     140,   141,   262,   114,   134,   226,   127,   135,    67,   254,
     132,   162,    88,   133,    72,    96,    69,   102,   155,   128,
     212,   213,   214,    97,    72,   100,    69,   106,   164,    98,
      71,   136,   137,    72,   142,   143,   144,   145,   204,   215,
      71,   148,   149,    72,   273,    69,    36,   107,    33,   174,
      47,    99,    48,   132,   170,   132,   133,   160,   133,    71,
     132,   146,   147,   133,   108,    72,   110,    69,   109,   167,
     282,   205,   207,   209,   210,   179,   111,   221,   183,   184,
     125,    71,   280,    36,    36,    33,    33,    47,    47,    48,
      48,   170,     9,    10,    11,    12,    13,    14,    15,    36,
      54,    33,   112,    47,   105,    48,   131,   223,   185,   186,
     206,   208,   150,   211,   187,   188,   228,   218,   231,   219,
     152,   240,   161,   241,    20,   171,   242,   243,   245,   246,
     175,   123,    36,   253,    33,   176,    47,   178,    48,   102,
     223,   193,   194,   195,   196,   197,   198,   204,   199,   200,
      36,    72,    33,    69,    47,   266,    48,    56,   252,   267,
     224,   225,   268,   269,   236,    66,   244,    71,   247,   248,
     237,   231,   238,   260,   264,    57,    58,   265,   270,   258,
     259,   189,   190,   191,   192,    36,   271,    33,   272,    47,
     275,    48,   277,    90,   202,   201,    19,   279,   263,    62,
      63,    64,   228,    65,   173,   276,   231,     0,   278,   235,
     274,    36,   252,    33,    56,    47,     0,    48,     0,     0,
       0,     0,     9,    10,    11,    12,    13,    14,    15,     0,
      54,     0,    57,    58,     0,     0,     0,     0,     0,     0,
      59,    60,     0,    61,     0,     0,     0,     0,     0,     0,
       0,     0,    18,    19,    20,    56,    62,    63,    64,     0,
      65,     0,    66,     9,    10,    11,    12,    13,    14,    15,
       0,    54,    67,    57,    58,     0,     0,   132,     0,     0,
     133,    59,     0,     0,    61,    56,     0,   212,     0,   214,
       0,     0,     0,     0,    19,    20,     0,    62,    63,    64,
       0,    65,     0,    57,    58,   204,   215,    56,     0,     0,
       0,    59,     0,    67,    61,     0,     0,     0,     0,   156,
     157,   158,   159,     0,    19,    57,    58,    62,    63,    64,
       0,    65,     0,    59,     0,     0,    61,    56,     0,     0,
       0,     0,   157,    67,   159,     0,    19,     0,     0,    62,
      63,    64,     0,    65,     0,    57,    58,     0,     0,     0,
       0,     0,     0,    59,     0,    67,    61,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    19,     0,     0,    62,
      63,    64,     0,    65,     0,     0,     0,     0,     0,     0,
     204,     0,     0,     1,     2,    67,     3,     4,     0,     5,
       6,     0,     7,     8,     9,    10,    11,    12,    13,    14,
      15,     0,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    18,    19,    20,     0,     0,    89,
       2,    21,     3,     4,     0,     5,     6,     0,     7,     8,
       9,    10,    11,    12,    13,    14,    15,     0,    16,    17,
       4,     0,     5,     6,     0,     7,     8,     9,    10,    11,
      12,    13,    14,    15,     0,    16,    17,     0,     0,     0,
      18,    19,    20,     0,     0,     0,     0,    21,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,    19,    20,
       0,     0,     0,     0,    21,     0,     0,     4,   168,     5,
       6,     0,     7,     8,     9,    10,    11,    12,    13,    14,
      15,     0,    16,    17,     4,     0,     5,     6,     0,     7,
       8,     9,    10,    11,    12,    13,    14,    15,     0,    16,
      17,     0,     0,     0,    18,    19,    20,     0,     0,     0,
       0,    21,     0,     0,     0,   222,     0,     0,     0,     0,
       0,    18,    19,    20,     0,     0,     0,     0,    21,     0,
       0,     4,   239,     5,     6,     0,     7,     8,     9,    10,
      11,    12,    13,    14,    15,     0,    16,    17,     4,     0,
       5,     6,     0,     7,     8,     9,    10,    11,    12,    13,
      14,    15,     0,    16,    17,     0,     0,     0,    18,    19,
      20,     0,     0,     0,     0,    21,     0,     0,   116,     0,
       0,     0,     0,     0,     0,    18,    19,    20,     0,     0,
       0,     0,    21,     9,    10,    11,    12,    13,    14,    15,
       0,    54,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,   172,    20
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-142))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       0,    17,     0,    17,     0,    17,     0,   106,     0,    28,
      44,     0,    31,   154,   113,    28,    49,    17,    31,    53,
       3,    55,    22,    44,    22,    48,    22,    16,    22,    18,
      22,    54,   131,    22,    55,    23,    24,    56,    21,    22,
      49,    42,    48,    56,    57,    51,    29,    28,    49,    32,
      31,    51,    59,    51,    61,    51,    49,    51,    28,    42,
      67,    31,    45,    46,    47,    54,    49,    42,    48,    50,
      58,    59,    52,    49,    27,   174,    65,    30,    61,   220,
      28,    49,    49,    31,   100,    48,   100,    55,   100,    65,
      38,    39,    40,     5,   110,    53,   110,    42,   110,    48,
     100,    25,    26,   119,    33,    34,    35,    36,    56,    57,
     110,    62,    63,   129,   255,   129,   116,    18,   116,   119,
     116,    48,   116,    28,   116,    28,    31,   103,    31,   129,
      28,    60,    61,    31,    48,   151,    53,   151,    48,   115,
     281,   156,   157,   158,   159,    50,    48,    50,   132,   133,
      42,   151,    50,   153,   154,   153,   154,   153,   154,   153,
     154,   153,    11,    12,    13,    14,    15,    16,    17,   169,
      19,   169,    48,   169,    54,   169,    42,   169,   134,   135,
     156,   157,    42,   159,   136,   137,   175,   163,   177,   165,
      52,   206,    42,   208,    43,     8,   211,   212,   213,   214,
      51,    49,   202,   218,   202,    49,   202,    50,   202,    55,
     202,   142,   143,   144,   145,   146,   147,    56,   148,   149,
     220,   237,   220,   237,   220,   237,   220,     3,   217,   244,
      49,    48,   247,   248,    52,    51,   212,   237,   214,   215,
      54,   230,    50,    42,    50,    21,    22,    54,    50,   225,
     226,   138,   139,   140,   141,   255,    54,   255,    42,   255,
      50,   255,    50,    22,   153,   151,    42,   271,   230,    45,
      46,    47,   261,    49,   119,   261,   265,    -1,   265,   178,
     256,   281,   271,   281,     3,   281,    -1,   281,    -1,    -1,
      -1,    -1,    11,    12,    13,    14,    15,    16,    17,    -1,
      19,    -1,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      29,    30,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    41,    42,    43,     3,    45,    46,    47,    -1,
      49,    -1,    51,    11,    12,    13,    14,    15,    16,    17,
      -1,    19,    61,    21,    22,    -1,    -1,    28,    -1,    -1,
      31,    29,    -1,    -1,    32,     3,    -1,    38,    -1,    40,
      -1,    -1,    -1,    -1,    42,    43,    -1,    45,    46,    47,
      -1,    49,    -1,    21,    22,    56,    57,     3,    -1,    -1,
      -1,    29,    -1,    61,    32,    -1,    -1,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    21,    22,    45,    46,    47,
      -1,    49,    -1,    29,    -1,    -1,    32,     3,    -1,    -1,
      -1,    -1,    38,    61,    40,    -1,    42,    -1,    -1,    45,
      46,    47,    -1,    49,    -1,    21,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    29,    -1,    61,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    45,
      46,    47,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      56,    -1,    -1,     0,     1,    61,     3,     4,    -1,     6,
       7,    -1,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    -1,    19,    20,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    41,    42,    43,    -1,    -1,     0,
       1,    48,     3,     4,    -1,     6,     7,    -1,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    -1,    19,    20,
       4,    -1,     6,     7,    -1,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    -1,    19,    20,    -1,    -1,    -1,
      41,    42,    43,    -1,    -1,    -1,    -1,    48,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    42,    43,
      -1,    -1,    -1,    -1,    48,    -1,    -1,     4,    52,     6,
       7,    -1,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    -1,    19,    20,     4,    -1,     6,     7,    -1,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    -1,    19,
      20,    -1,    -1,    -1,    41,    42,    43,    -1,    -1,    -1,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    41,    42,    43,    -1,    -1,    -1,    -1,    48,    -1,
      -1,     4,    52,     6,     7,    -1,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    -1,    19,    20,     4,    -1,
       6,     7,    -1,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    -1,    19,    20,    -1,    -1,    -1,    41,    42,
      43,    -1,    -1,    -1,    -1,    48,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    42,    43,    -1,    -1,
      -1,    -1,    48,    11,    12,    13,    14,    15,    16,    17,
      -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    41,    42,    43
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     0,     1,     3,     4,     6,     7,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    19,    20,    41,    42,
      43,    48,    65,    66,    67,    69,    74,    75,    77,    79,
      83,    86,    91,    92,    94,   101,   102,   103,   105,   106,
     107,   109,   114,   117,   120,   121,   122,   123,   124,    49,
      49,    87,    49,    42,    19,   105,     3,    21,    22,    29,
      30,    32,    45,    46,    47,    49,    51,    61,    92,    94,
      96,   102,   103,   105,   123,   124,   125,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   105,    49,     0,
      66,    48,    51,    70,    71,    73,    48,     5,    48,    48,
      53,    44,    55,   118,    48,    54,    42,    18,    48,    48,
      53,    48,    48,   102,   129,    80,    51,    89,    91,    84,
     115,   105,    42,    49,   136,    42,   136,   105,   129,   126,
     136,    42,    28,    31,    27,    30,    25,    26,    23,    24,
      58,    59,    33,    34,    35,    36,    60,    61,    62,    63,
      42,    93,    52,    72,    78,    96,    37,    38,    39,    40,
     129,    42,    49,   118,    96,   118,    50,   129,    52,    90,
      91,     8,    42,   101,   102,    51,    49,   110,    50,    50,
      95,    96,    97,   130,   130,   131,   131,   132,   132,   133,
     133,   133,   133,   134,   134,   134,   134,   134,   134,   135,
     135,    95,    90,    89,    56,   119,   129,   119,   129,   119,
     119,   129,    38,    39,    40,    57,   119,    68,   129,   129,
      76,    50,    52,    91,    49,    48,   118,   104,   105,   116,
     108,   105,   111,   112,   113,   125,    52,    54,    50,    52,
     119,   119,   119,   119,   129,   119,   119,   129,   129,    98,
      99,   100,   105,   119,    89,    81,    88,    82,   129,   129,
      42,    48,    52,   111,    50,    54,    96,   119,   119,   119,
      50,    54,    42,    89,   129,    50,   104,    50,   113,   100,
      50,    85,    89
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 286 "tell_yacc.yy"
    {}
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 287 "tell_yacc.yy"
    {}
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 291 "tell_yacc.yy"
    {
      if (!yynerrs) 
      {
         CMDBlock->execute();
      }
      else
      {
         CMDBlock = CMDBlock->rootBlock();
         CMDBlock->cleaner();
         parsercmd::EOfile();
      }
   }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 303 "tell_yacc.yy"
    {}
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 304 "tell_yacc.yy"
    {
      delete((yyvsp[(1) - (2)].pfdeclaration)); cfd = NULL;
   }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 307 "tell_yacc.yy"
    {
      tellerror("Unexpected symbol", (yylsp[(1) - (1)]));
      parsercmd::EOfile();
   }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 311 "tell_yacc.yy"
    {
     /*end of file but in our case rather empty input buffer*/
   }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 314 "tell_yacc.yy"
    {
      CMDBlock = CMDBlock->rootBlock();
      CMDBlock->cleaner();
      parsercmd::EOfile();
      /*yynerrs = 0;*/
   }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 323 "tell_yacc.yy"
    {
      cfd = DEBUG_NEW parsercmd::FuncDeclaration((yyvsp[(2) - (3)].parsestr), (yyvsp[(1) - (3)].pttname)) ;
   }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 326 "tell_yacc.yy"
    {
      CMDBlock->addUSERFUNCDECL(cfd,(yyloc));
      (yyval.pfdeclaration) = cfd;
      delete [] (yyvsp[(2) - (6)].parsestr);
   }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 334 "tell_yacc.yy"
    {
      CMDBlock->addUSERFUNC((yyvsp[(1) - (2)].pfdeclaration), (yyvsp[(2) - (2)].pfblock), (yyloc));
      // addUSERFUNC will take care about cleaning the funcdeclaration ($1) and funcblock ($2)
      cfd = NULL;
   }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 343 "tell_yacc.yy"
    {}
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 344 "tell_yacc.yy"
    {}
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 348 "tell_yacc.yy"
    {
         CMDBlock = DEBUG_NEW parsercmd::cmdFUNC(cfd->argListCopy(),cfd->type(),false, (yylsp[(1) - (1)]));
         CMDBlock->pushblk();
      }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 352 "tell_yacc.yy"
    {
         (yyval.pfblock) = static_cast<parsercmd::cmdFUNC*>(CMDBlock);
         CMDBlock = CMDBlock->popblk();
      }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 359 "tell_yacc.yy"
    {
         (yyval.pfblock) = NULL;
         tellerror("Empty function definition.", (yylsp[(1) - (2)]));
      }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 365 "tell_yacc.yy"
    {
      if (!cfd) tellerror("return statement outside function body", (yylsp[(1) - (1)]));
      else {
         parsercmd::cmdRETURN* rcmd = DEBUG_NEW parsercmd::cmdRETURN(cfd->type());
         if (rcmd->checkRetype(NULL)) CMDBlock->pushcmd(rcmd);
         else {
            tellerror("return value expected", (yylsp[(1) - (1)]));
            delete rcmd;
         }
      }
      cfd->incReturns();
   }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 377 "tell_yacc.yy"
    {
      if (!cfd) tellerror("return statement outside function body", (yylsp[(1) - (2)]));
      else {
         parsercmd::cmdRETURN* rcmd = DEBUG_NEW parsercmd::cmdRETURN(cfd->type());
         if (rcmd->checkRetype((yyvsp[(2) - (2)].parguments))) CMDBlock->pushcmd(rcmd);
         else {
            tellerror("return type different from function type", (yylsp[(2) - (2)]));
            delete rcmd;
         }
         delete (yyvsp[(2) - (2)].parguments);
      }
      cfd->incReturns();
   }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 393 "tell_yacc.yy"
    {
         CMDBlock = DEBUG_NEW parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
     }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 397 "tell_yacc.yy"
    {
         parsercmd::cmdBLOCK* if_block = CMDBlock;
         CMDBlock = CMDBlock->popblk();
         if (telldata::tn_bool != (yyvsp[(3) - (6)].pttname)) {
            tellerror("bool type expected",(yylsp[(3) - (6)]));
            delete if_block;
            (yyval.pblock) = NULL;
         }
         else {
            (yyval.pblock) = if_block;
         }
      }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 412 "tell_yacc.yy"
    {
        if (NULL != (yyvsp[(1) - (1)].pblock))
           CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdIFELSE((yyvsp[(1) - (1)].pblock), NULL));
   }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 416 "tell_yacc.yy"
    {
         CMDBlock = DEBUG_NEW parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
   }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 420 "tell_yacc.yy"
    {
         parsercmd::cmdBLOCK* else_block = CMDBlock;
         CMDBlock = CMDBlock->popblk();
         if (NULL != (yyvsp[(1) - (4)].pblock))
            CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdIFELSE((yyvsp[(1) - (4)].pblock),else_block));
      }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 429 "tell_yacc.yy"
    {
         CMDBlock = DEBUG_NEW parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
      }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 433 "tell_yacc.yy"
    {
         if (telldata::tn_bool != (yyvsp[(4) - (5)].pttname)) tellerror("bool type expected", (yylsp[(4) - (5)]));
         CMDBlock = DEBUG_NEW parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
      }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 438 "tell_yacc.yy"
    {
         parsercmd::cmdBLOCK* body_block = CMDBlock;
         CMDBlock = CMDBlock->popblk();
         parsercmd::cmdBLOCK* cond_block = CMDBlock;
         CMDBlock = CMDBlock->popblk();
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdWHILE(cond_block,body_block));
      }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 448 "tell_yacc.yy"
    {
         if       (!((yyvsp[(1) - (1)].pttname) & telldata::tn_listmask)) {
            tellerror("list expected",(yylsp[(1) - (1)]));
            (yyval.pttname) = telldata::tn_NULL;
         }
         else
            (yyval.pttname) = (yyvsp[(1) - (1)].pttname);
      }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 459 "tell_yacc.yy"
    {
         CMDBlock = DEBUG_NEW parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
      }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 463 "tell_yacc.yy"
    {
         if  (((yyvsp[(4) - (7)].pttname) | telldata::tn_listmask) != (yyvsp[(6) - (7)].pttname))
            tellerror("unappropriate variable type",(yylsp[(4) - (7)]));
         foreach_stack.push(DEBUG_NEW parsercmd::cmdFOREACH(tell_lvalue));
         CMDBlock = DEBUG_NEW parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
      }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 470 "tell_yacc.yy"
    {
         parsercmd::cmdBLOCK* body_block = CMDBlock;
         CMDBlock = CMDBlock->popblk();
         parsercmd::cmdBLOCK* header_block = CMDBlock;
         CMDBlock = CMDBlock->popblk();
         parsercmd::cmdFOREACH* cur_foreach = foreach_stack.top(); foreach_stack.pop();
         cur_foreach->addBlocks(header_block, body_block);
         CMDBlock->pushcmd(cur_foreach);
      }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 482 "tell_yacc.yy"
    {
         CMDBlock = DEBUG_NEW parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
      }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 486 "tell_yacc.yy"
    {
         CMDBlock = DEBUG_NEW parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
      }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 490 "tell_yacc.yy"
    {
         parsercmd::cmdBLOCK* cond_block = CMDBlock;
         CMDBlock = CMDBlock->popblk();
         parsercmd::cmdBLOCK* body_block = CMDBlock;
         CMDBlock = CMDBlock->popblk();
         if (telldata::tn_bool != (yyvsp[(7) - (8)].pttname)) {
            tellerror("bool type expected", (yylsp[(7) - (8)]));
            delete cond_block;
         }
         else CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdREPEAT(cond_block,body_block));
   }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 504 "tell_yacc.yy"
    { }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 505 "tell_yacc.yy"
    { }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 506 "tell_yacc.yy"
    { }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 510 "tell_yacc.yy"
    { }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 511 "tell_yacc.yy"
    { }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 515 "tell_yacc.yy"
    { }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 516 "tell_yacc.yy"
    { }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 517 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 518 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 519 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 520 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 521 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 522 "tell_yacc.yy"
    {/*keep the return value in the stack*/}
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 523 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 524 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 525 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 526 "tell_yacc.yy"
    { }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 527 "tell_yacc.yy"
    { }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 531 "tell_yacc.yy"
    {
        argmap = DEBUG_NEW telldata::argumentQ;
        argmapstack.push(argmap);
   }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 535 "tell_yacc.yy"
    {
      std::string lclErrorMsg;
      parsercmd::cmdSTDFUNC *fc = CMDBlock->getFuncBody((yyvsp[(1) - (5)].parsestr),(yyvsp[(4) - (5)].plarguments),lclErrorMsg);
      if (fc) {
         if (parsercmd::vplFunc((yyvsp[(1) - (5)].parsestr)))
            /* functions with a variable parameter list require special attention */
            CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdNUMFPARAMS((yyvsp[(4) - (5)].plarguments)));
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdFUNCCALL(fc,(yyvsp[(1) - (5)].parsestr)));
         (yyval.pttname) = fc->gettype();
      }
      else {
         tellerror(lclErrorMsg,(yylsp[(1) - (5)]));
         (yyval.pttname) = telldata::tn_NULL;
      }
      telldata::argQClear(argmap);
      argmapstack.pop();
      delete argmap;
      if (argmapstack.size() > 0) argmap = argmapstack.top();
      else argmap = NULL;
      delete [] (yyvsp[(1) - (5)].parsestr);
   }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 559 "tell_yacc.yy"
    {
      /*because of the (possible) structure that has an unknown yet tn_usertypes type,
      here we are doing the type checking, using the type of the lvalue*/
      (yyval.pttname) = parsercmd::Assign(tell_lvalue, lindexed, (yyvsp[(3) - (3)].parguments), (yylsp[(2) - (3)]));
      delete (yyvsp[(3) - (3)].parguments);
   }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 565 "tell_yacc.yy"
    {
      (yyval.pttname) = parsercmd::Uninsert(tell_lvalue, (yyvsp[(3) - (3)].parguments), listadd_command, (yylsp[(2) - (3)]));
      delete (yyvsp[(3) - (3)].parguments);
      listadd_command = NULL;
   }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 573 "tell_yacc.yy"
    {(yyval.plarguments) = NULL;}
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 574 "tell_yacc.yy"
    {(yyval.plarguments) = (yyvsp[(1) - (1)].plarguments);}
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 578 "tell_yacc.yy"
    {(yyval.parguments) = DEBUG_NEW telldata::ArgumentID((yyvsp[(1) - (1)].pttname));}
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 579 "tell_yacc.yy"
    {(yyval.parguments) = DEBUG_NEW telldata::ArgumentID((yyvsp[(1) - (1)].pttname));}
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 580 "tell_yacc.yy"
    {(yyval.parguments) = (yyvsp[(1) - (1)].parguments);}
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 581 "tell_yacc.yy"
    {(yyval.parguments) = (yyvsp[(1) - (1)].parguments);}
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 585 "tell_yacc.yy"
    {argmap->push_back((yyvsp[(1) - (1)].parguments)); (yyval.plarguments) = argmap;}
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 586 "tell_yacc.yy"
    {argmap->push_back((yyvsp[(3) - (3)].parguments)); (yyval.plarguments) = argmap;}
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 590 "tell_yacc.yy"
    {}
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 591 "tell_yacc.yy"
    {}
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 595 "tell_yacc.yy"
    {}
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 596 "tell_yacc.yy"
    {}
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 600 "tell_yacc.yy"
    {
      tellvar = CMDBlock->newFuncArg((yyvsp[(1) - (2)].pttname), (yylsp[(1) - (2)]));
      assert(NULL != tellvar);
      cfd->pushArg(DEBUG_NEW parsercmd::ArgumentTYPE((yyvsp[(2) - (2)].parsestr),tellvar));
      delete [] (yyvsp[(2) - (2)].parsestr);
   }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 609 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);tell_lvalue = tellvar; lindexed = indexed;}
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 610 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);tell_lvalue = tellvar; lindexed = indexed;}
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 614 "tell_yacc.yy"
    {
      tellvar = CMDBlock->getID((yyvsp[(1) - (1)].parsestr));
      if (tellvar) (yyval.pttname) = tellvar->get_type();
      else
      {
         tellerror("variable not defined in this scope", (yylsp[(1) - (1)]));
         (yyval.pttname) = telldata::tn_NULL;
      }
      delete [] (yyvsp[(1) - (1)].parsestr);
      indexed = 0;
   }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 625 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname); indexed = 0;}
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 626 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname); indexed = 1;}
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 627 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname); indexed = 2;}
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 633 "tell_yacc.yy"
    {
      telldata::TellVar* v = CMDBlock->getID((yyvsp[(2) - (2)].parsestr), true);
      if (!v) {/* if this variableID doesn't exist already in the local scope*/
         /* add it to the local variable map */
         tellvar = CMDBlock->newTellvar((yyvsp[(1) - (2)].pttname), (yyvsp[(2) - (2)].parsestr), (yylsp[(1) - (2)]));
         CMDBlock->addID((yyvsp[(2) - (2)].parsestr),tellvar);
      }
      else
         tellerror("variable already defined in this scope", (yylsp[(2) - (2)]));
      (yyval.pttname) = (yyvsp[(1) - (2)].pttname); delete [] (yyvsp[(2) - (2)].parsestr);indexed = 0;
   }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 644 "tell_yacc.yy"
    {
      telldata::TellVar* v = CMDBlock->getID((yyvsp[(2) - (5)].parsestr), true);
      if (!v) {/* if this variableID doesn't exist already in the local scope*/
         /* add it to the local variable map */
         if (parsercmd::ListIndexCheck((yyvsp[(1) - (5)].pttname), (yylsp[(1) - (5)]), (yyvsp[(4) - (5)].pttname), (yylsp[(4) - (5)])))
         {
            tellvar = CMDBlock->newTellvar((yyvsp[(1) - (5)].pttname), (yyvsp[(2) - (5)].parsestr), (yylsp[(1) - (5)]));
            CMDBlock->addID((yyvsp[(2) - (5)].parsestr),tellvar);
            CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSIZE(tellvar));
         }
      }
      else
         tellerror("variable already defined in this scope", (yylsp[(2) - (5)]));
      (yyval.pttname) = (yyvsp[(1) - (5)].pttname); delete [] (yyvsp[(2) - (5)].parsestr);indexed = 0;
   }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 659 "tell_yacc.yy"
    {
      telldata::TellVar* v = CMDBlock->getID((yyvsp[(3) - (3)].parsestr), true);
      if (!v) {/* if this variableID doesn't exist already in the local scope*/
         /* add it to the local variable map */
         tellvar = CMDBlock->newTellvar((yyvsp[(2) - (3)].pttname), (yyvsp[(3) - (3)].parsestr), (yylsp[(2) - (3)]));
         CMDBlock->addconstID((yyvsp[(3) - (3)].parsestr),tellvar,false);
      }
      else
         tellerror("variable already defined in this scope", (yylsp[(2) - (3)]));
      (yyval.pttname) = (yyvsp[(2) - (3)].pttname); delete [] (yyvsp[(3) - (3)].parsestr);indexed = 0;
   }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 670 "tell_yacc.yy"
    {
      telldata::TellVar* v = CMDBlock->getID((yyvsp[(3) - (3)].parsestr), true);
      if (!v) {/* if this variableID doesn't exist already in the local scope*/
         /* add it to the local variable map */
         tellvar = CMDBlock->newTellvar((yyvsp[(1) - (3)].pttname), (yyvsp[(3) - (3)].parsestr), (yylsp[(1) - (3)]));
         CMDBlock->addID((yyvsp[(3) - (3)].parsestr),tellvar);
      }
      else tellerror("variable already defined in this scope", (yylsp[(3) - (3)]));
      (yyval.pttname) = (yyvsp[(1) - (3)].pttname); delete [] (yyvsp[(3) - (3)].parsestr);indexed = 0;
   }
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 683 "tell_yacc.yy"
    {
      const telldata::TType* ftype =
            CMDBlock->getTypeByID((yyvsp[(1) - (2)].pttname) & ~telldata::tn_listmask);
      if (!tellstruct->addfield((yyvsp[(2) - (2)].parsestr), (yyvsp[(1) - (2)].pttname), ftype)) {
         tellerror("field with this name already defined in this strucutre", (yylsp[(2) - (2)]));
         (yyval.ptypedef) = false; // indicates that definition fails
      }
      else (yyval.ptypedef) = true;
      delete [] (yyvsp[(2) - (2)].parsestr);
   }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 696 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 697 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (2)].pttname) | telldata::tn_listmask;}
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 698 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname); /*TODO - check! should be OK to have call back lists*/}
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 702 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_void;}
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 703 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_real;}
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 704 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_int;}
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 705 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_bool;}
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 706 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_string;}
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 707 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_layout;}
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 708 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_auxilary;}
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 709 "tell_yacc.yy"
    {
        const telldata::TType* ttype = CMDBlock->getTypeByName((yyvsp[(1) - (1)].parsestr));
        // the lexer shall generate tknTYPEdef if and only of the identifier is
        // a known type name. The assert is to double check this.
        assert (NULL != ttype); 
        (yyval.pttname) = ttype->ID();
        delete [] (yyvsp[(1) - (1)].parsestr);
      }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 720 "tell_yacc.yy"
    {
        tellcallback = CMDBlock->secureCallBackType((yyvsp[(3) - (4)].parsestr));
        if (NULL == tellcallback) {
           tellerror("type with this name already defined", (yylsp[(2) - (4)]));
           delete [] (yyvsp[(3) - (4)].parsestr);
           cleanonabort();
           YYABORT;
        }
        tellcallback->setFType((yyvsp[(2) - (4)].pttname));
     }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 730 "tell_yacc.yy"
    {
        CMDBlock->addlocaltype((yyvsp[(3) - (7)].parsestr),tellcallback);
        delete [] (yyvsp[(3) - (7)].parsestr);
        tellcallback = NULL;
     }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 738 "tell_yacc.yy"
    {
        tellcallback = CMDBlock->secureCallBackType(NULL);
        assert (NULL != tellcallback);
        tellcallback->setFType((yyvsp[(2) - (3)].pttname));
     }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 743 "tell_yacc.yy"
    {
        CMDBlock->addAnoLoType(tellcallback);
        (yyval.pttname) = tellcallback->ID(); 
        tellcallback = NULL;
     }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 751 "tell_yacc.yy"
    {}
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 752 "tell_yacc.yy"
    {}
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 756 "tell_yacc.yy"
    {}
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 757 "tell_yacc.yy"
    {}
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 761 "tell_yacc.yy"
    {
        tellcallback->pushArg((yyvsp[(1) - (1)].pttname));
   }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 767 "tell_yacc.yy"
    {
        tellstruct = CMDBlock->secureCompType((yyvsp[(2) - (2)].parsestr));
        if (NULL == tellstruct) {
           tellerror("type with this name already defined", (yylsp[(1) - (2)]));
           delete [] (yyvsp[(2) - (2)].parsestr);
           cleanonabort();
           YYABORT;
        }
     }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 776 "tell_yacc.yy"
    {
        if ((yyvsp[(5) - (6)].ptypedef)) CMDBlock->addlocaltype((yyvsp[(2) - (6)].parsestr),tellstruct);
        else delete tellstruct;
        tellstruct = NULL;
        delete [] (yyvsp[(2) - (6)].parsestr);
     }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 785 "tell_yacc.yy"
    { (yyval.ptypedef) = (yyvsp[(1) - (1)].ptypedef);      }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 786 "tell_yacc.yy"
    { (yyval.ptypedef) = (yyvsp[(1) - (3)].ptypedef) && (yyvsp[(3) - (3)].ptypedef);}
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 790 "tell_yacc.yy"
    {
      if (NULL == tellvar)
      {
         tellerror("Unexisting variable", (yylsp[(1) - (2)]));
         cleanonabort();
         YYABORT;
      }
      else if (indexed)
      {
         tellerror("Can't dereference a field of a listed structures(Bug #14112). Please use intermediate variables.", (yylsp[(1) - (2)]));
         (yyval.pttname) = telldata::tn_NULL;
      }
      else
      {
         tellvar = tellvar->field_var((yyvsp[(2) - (2)].parsestr));
         if (tellvar) (yyval.pttname) = tellvar->get_type();
         else
         {
            tellerror("Bad field identifier", (yylsp[(2) - (2)]));
            (yyval.pttname) = telldata::tn_NULL;
         }
      }
      delete [] (yyvsp[(2) - (2)].parsestr);
   }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 817 "tell_yacc.yy"
    {
      tellindxvar.push(tellvar);
    }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 823 "tell_yacc.yy"
    {
      tellvar = tellindxvar.top();
      tellindxvar.pop();
    }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 831 "tell_yacc.yy"
    {
      if (parsercmd::ListIndexCheck((yyvsp[(1) - (4)].pttname), (yylsp[(1) - (4)]), (yyvsp[(3) - (4)].pttname), (yylsp[(3) - (4)])))
      {
         (yyval.pttname) = ((yyvsp[(1) - (4)].pttname) & (~telldata::tn_listmask));
      }
      else {
         (yyval.pttname) = telldata::tn_NULL;
      }
    }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 843 "tell_yacc.yy"
    {
      if (parsercmd::ListIndexCheck((yyvsp[(1) - (6)].pttname), (yylsp[(1) - (6)]), (yyvsp[(3) - (6)].pttname), (yylsp[(3) - (6)])) &&
          parsercmd::ListIndexCheck((yyvsp[(1) - (6)].pttname), (yylsp[(1) - (6)]), (yyvsp[(5) - (6)].pttname), (yylsp[(5) - (6)])))
      {
         (yyval.pttname) = (yyvsp[(1) - (6)].pttname);
      }
      else {
         (yyval.pttname) = telldata::tn_NULL;
      }
    }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 856 "tell_yacc.yy"
    {
      if (parsercmd::ListIndexCheck((yyvsp[(1) - (5)].pttname), (yylsp[(1) - (5)]), (yyvsp[(4) - (5)].pttname), (yylsp[(4) - (5)])))
      {
         listadd_command = DEBUG_NEW parsercmd::cmdLISTADD(tellvar,true, true);
         (yyval.pttname) = (yyvsp[(1) - (5)].pttname); tell_lvalue = tellvar; lindexed = 1;
      }
      else {
         (yyval.pttname) = telldata::tn_NULL; listadd_command = NULL;
      }
    }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 866 "tell_yacc.yy"
    {
      if ((yyvsp[(1) - (4)].pttname) & telldata::tn_listmask) {
         listadd_command = DEBUG_NEW parsercmd::cmdLISTADD(tellvar,true, false);
         (yyval.pttname) = (yyvsp[(1) - (4)].pttname); tell_lvalue = tellvar; lindexed = 1;
      }
      else {
         tellerror("list expected",(yylsp[(1) - (4)]));
         (yyval.pttname) = telldata::tn_NULL; listadd_command = NULL;
      }
    }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 876 "tell_yacc.yy"
    {
      if (parsercmd::ListIndexCheck((yyvsp[(1) - (5)].pttname), (yylsp[(1) - (5)]), (yyvsp[(3) - (5)].pttname), (yylsp[(3) - (5)])))
      {
         listadd_command = DEBUG_NEW parsercmd::cmdLISTADD(tellvar,false, true);
         (yyval.pttname) = (yyvsp[(1) - (5)].pttname); tell_lvalue = tellvar; lindexed = 1;
      }
      else {
         (yyval.pttname) = telldata::tn_NULL; listadd_command = NULL;
      }
    }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 886 "tell_yacc.yy"
    {
      if ((yyvsp[(1) - (4)].pttname) & telldata::tn_listmask) {
         listadd_command = DEBUG_NEW parsercmd::cmdLISTADD(tellvar,false, false);
         (yyval.pttname) = (yyvsp[(1) - (4)].pttname); tell_lvalue = tellvar; lindexed = 1;
      }
      else {
         tellerror("list expected",(yylsp[(1) - (4)]));
         (yyval.pttname) = telldata::tn_NULL; listadd_command = NULL;
      }
    }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 899 "tell_yacc.yy"
    {
      if (parsercmd::ListIndexCheck((yyvsp[(1) - (5)].pttname), (yylsp[(1) - (5)]), (yyvsp[(4) - (5)].pttname), (yylsp[(4) - (5)])))
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSUB(tellvar,true, true));
      (yyval.pttname) = ((yyvsp[(1) - (5)].pttname) & (~telldata::tn_listmask));
    }
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 904 "tell_yacc.yy"
    {
      if ((yyvsp[(1) - (4)].pttname) & telldata::tn_listmask)
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSUB(tellvar,true, false));
      else
         tellerror("list expected",(yylsp[(1) - (4)]));
      (yyval.pttname) = ((yyvsp[(1) - (4)].pttname) & (~telldata::tn_listmask));
    }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 911 "tell_yacc.yy"
    {
      if (parsercmd::ListIndexCheck((yyvsp[(1) - (5)].pttname), (yylsp[(1) - (5)]), (yyvsp[(3) - (5)].pttname), (yylsp[(3) - (5)])))
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSUB(tellvar,false, true));
      (yyval.pttname) = ((yyvsp[(1) - (5)].pttname) & (~telldata::tn_listmask));
    }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 916 "tell_yacc.yy"
    {
      if ((yyvsp[(1) - (4)].pttname) & telldata::tn_listmask)
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSUB(tellvar,false, false));
      else
         tellerror("list expected",(yylsp[(1) - (4)]));
      (yyval.pttname) = ((yyvsp[(1) - (4)].pttname) & (~telldata::tn_listmask));
    }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 926 "tell_yacc.yy"
    {
      if (parsercmd::ListSliceCheck((yyvsp[(1) - (6)].pttname), (yylsp[(1) - (6)]), (yyvsp[(5) - (6)].pttname), (yylsp[(5) - (6)]), (yyvsp[(3) - (6)].pttname), (yylsp[(3) - (6)])))
      {
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSLICE(tellvar, true, true));
         (yyval.pttname) = (yyvsp[(1) - (6)].pttname);
      }
      else
         (yyval.pttname) = telldata::tn_NULL;
    }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 935 "tell_yacc.yy"
    {
      if (parsercmd::ListSliceCheck((yyvsp[(1) - (5)].pttname), (yylsp[(1) - (5)]), (yyvsp[(3) - (5)].pttname), (yylsp[(3) - (5)])))
      {
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSLICE(tellvar, false, false));
         (yyval.pttname) = (yyvsp[(1) - (5)].pttname);
      }
      else
         (yyval.pttname) = telldata::tn_NULL;
    }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 944 "tell_yacc.yy"
    {
      if (parsercmd::ListSliceCheck((yyvsp[(1) - (6)].pttname), (yylsp[(1) - (6)]), (yyvsp[(3) - (6)].pttname), (yylsp[(3) - (6)]), (yyvsp[(5) - (6)].pttname), (yylsp[(5) - (6)])))
      {
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSLICE(tellvar, false, true));
         (yyval.pttname) = (yyvsp[(1) - (6)].pttname);
      }
      else
         (yyval.pttname) = telldata::tn_NULL;
    }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 953 "tell_yacc.yy"
    {
      if (parsercmd::ListSliceCheck((yyvsp[(1) - (5)].pttname), (yylsp[(1) - (5)]), (yyvsp[(4) - (5)].pttname), (yylsp[(4) - (5)])))
      {
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSLICE(tellvar, true, false));
         (yyval.pttname) = (yyvsp[(1) - (5)].pttname);
      }
      else
         (yyval.pttname) = telldata::tn_NULL;
    }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 965 "tell_yacc.yy"
    {
        argmap = DEBUG_NEW telldata::argumentQ;
        argmapstack.push(argmap);
   }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 969 "tell_yacc.yy"
    {
        /*Important note!. Here we will get a list of components that could be
          a tell list or some kind of tell struct or even tell list of tell struct.
          There is no way at this moment to determine the type of the input structure
          for (seems) obvious reasons. So - the type check and the eventual pushcmd
          are postponed until we get the recepient - i.e. the lvalue or the
          function call. $$ is assigned to ArgumentID, that caries the whole argument
          queue listed in structure*/
        parsercmd::cmdSTRUCT* struct_command = DEBUG_NEW parsercmd::cmdSTRUCT();
        CMDBlock->pushcmd(struct_command);
        (yyval.parguments) = DEBUG_NEW telldata::ArgumentID(argmap, struct_command);
        //argQClear(argmap);
        argmapstack.pop();
        delete argmap;
        if (argmapstack.size() > 0) argmap = argmapstack.top();
        else argmap = NULL;
   }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 989 "tell_yacc.yy"
    {
        parsercmd::cmdFUNCREF* funcref = DEBUG_NEW parsercmd::cmdFUNCREF((yyvsp[(2) - (2)].parsestr));
        CMDBlock->pushcmd(funcref);
        (yyval.parguments) = DEBUG_NEW telldata::ArgumentID(funcref);
        delete [] (yyvsp[(2) - (2)].parsestr);
   }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 997 "tell_yacc.yy"
    {
      telldata::ArgumentID* op2 = (yyvsp[(4) - (4)].parguments);
      // the structure is without a type at this moment, so here we do the type checking
      if (parsercmd::StructTypeCheck((yyvsp[(2) - (4)].pttname), op2, (yylsp[(4) - (4)]))) {
         tellvar = CMDBlock->newTellvar((yyvsp[(2) - (4)].pttname), "", (yylsp[(1) - (4)]));
         parsercmd::Assign(tellvar, false, (yyvsp[(4) - (4)].parguments), (yylsp[(4) - (4)]));
         delete (yyvsp[(4) - (4)].parguments);
         (yyval.pttname) = (yyvsp[(2) - (4)].pttname);
      }
      else {
         tellerror("Type mismatch", (yylsp[(4) - (4)]));
         (yyval.pttname) = telldata::tn_NULL;
         delete (yyvsp[(4) - (4)].parguments);
         cleanonabort();
         YYABORT;
      }
   }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 1019 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 1020 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"||",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 1021 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"|",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 1025 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 1026 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"&&",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 1027 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname), "&",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 1031 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 1032 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"==",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 1033 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"!=",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 1037 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 1038 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"<",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 137:

/* Line 1806 of yacc.c  */
#line 1039 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),">",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 1040 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"<=",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 1041 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),">=",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 1045 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 1046 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::Plus((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]));}
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 1047 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::Minus((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]));}
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 1048 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::PointMv((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]),+1,+1);}
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 1049 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::PointMv((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]),-1,+1);}
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 1050 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::PointMv((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]),+1,-1);}
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 1051 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::PointMv((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]),-1,-1);}
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 1055 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 1056 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::Multiply((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]));}
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 1057 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::Divide((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]));}
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 1061 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 1062 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::UMinus((yyvsp[(2) - (2)].pttname),(yylsp[(2) - (2)]));}
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 1063 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(2) - (2)].pttname), "!",(yylsp[(2) - (2)]));}
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 1064 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(2) - (2)].pttname), "~",(yylsp[(2) - (2)]));}
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 1068 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_real;
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdPUSH(DEBUG_NEW telldata::TtReal((yyvsp[(1) - (1)].real)), false, true));}
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 1070 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_int;
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdPUSH(DEBUG_NEW telldata::TtInt((yyvsp[(1) - (1)].integer)), false, true));}
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 1072 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_bool;
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdPUSH(DEBUG_NEW telldata::TtBool(true), false, true));}
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 1074 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_bool;
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdPUSH(DEBUG_NEW telldata::TtBool(false), false, true));}
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 1076 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_string;
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdPUSH(DEBUG_NEW telldata::TtString((yyvsp[(1) - (1)].parsestr)), false, true));
                                                                delete [] (yyvsp[(1) - (1)].parsestr);}
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 1079 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdPUSH(tellvar, indexed));}
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 1081 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdANOVAR(tellvar));}
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 1083 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname); indexed = 0;}
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 1084 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname); indexed = 0;}
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 1085 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(2) - (3)].pttname);}
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 1086 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 1087 "tell_yacc.yy"
    {tellerror("Unexpected symbol", (yylsp[(1) - (1)]));}
    break;



/* Line 1806 of yacc.c  */
#line 3565 "tell_yacc.cc"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 1090 "tell_yacc.yy"

/*-------------------------------------------------------------------------*/
int tellerror (char *s)
{  /* Called by yyparse on error */
   std::ostringstream ost;
   ost << "line " << telllloc.first_line << ": col " << telllloc.first_column
       << ": " << s;
   tell_log(console::MT_ERROR,ost.str());
   return 0;
}

void tellerror (std::string s, TpdYYLtype loc)
{
   if (cfd) cfd->incErrors();
   else     yynerrs++;
   std::ostringstream ost;
   ost << "line " << loc.first_line << ": col " << loc.first_column << ": ";
   if (loc.filename) {
      std::string fn = loc.filename;
      ost << "in file \"" << fn << "\" : ";
   }
   ost << s;
   tell_log(console::MT_ERROR,ost.str());
}

void tellerror (std::string s)
{
   if (cfd) cfd->incErrors();
   else     yynerrs++;
   std::ostringstream ost;
   ost << "line " << telllloc.first_line << ": col " << telllloc.first_column << ": " << s;
   tell_log(console::MT_ERROR,ost.str());
}

void cleanonabort()
{
   CMDBlock = CMDBlock->rootBlock();
   CMDBlock->cleaner();
   parsercmd::EOfile();
   while (!foreach_stack.empty())
   {
	   delete(foreach_stack.top());foreach_stack.pop();
   }
   if (listadd_command) {delete listadd_command;listadd_command   = NULL;}
   if (tellstruct)      {delete tellstruct;     tellstruct        = NULL;}
   if (argmap)          {delete argmap;         argmap            = NULL;}
   if (cfd)             {delete cfd;            cfd               = NULL;}
   tell_lvalue       = NULL;
   tellvar           = NULL;
   while (!tellindxvar.empty()) tellindxvar.pop(); 
}


